/**
 * @file
 * Dropbutton feature.
 */

(function ($, Drupal) {

  'use strict';

	$(document).ready(function() {

		var popup_settings = drupalSettings.simple_popup_blocks.settings;
		$.each(popup_settings, function (index, values) {
			var block_id = values.identifier;
			var visit_counts_arr = values.visit_counts.split(",");
			var allow_cookie = true;
			var cookie_val = 1;
			if (visit_counts_arr.length == 1 && visit_counts_arr[0] == 0) {
				var allow_cookie = false;
			} 
			if (allow_cookie == true) {				
				var read_cookie = readCookie("spb_"+block_id);
				if(read_cookie) {
					cookie_val = +read_cookie + 1;
					createCookie("spb_"+block_id,cookie_val,100);					
				}
				else {
					createCookie("spb_"+block_id,cookie_val,100);
				}
			}
			cookie_val = cookie_val.toString();
			var match = $.inArray(cookie_val, visit_counts_arr);		
			// console.log(visit_counts_arr);
			// console.log(cookie_val);
			// console.log(match);
			if (values.status == 0 || (match == -1 && allow_cookie == true)) {
				return true;
			}

			var css_identity = '.';	
			if (values.css_selector == 1) {
				css_identity = '#';
			}					  
		  var modal_class = block_id+"-modal";
		  var modal_close_class = block_id+"-modal-close";
		  var modal_minimize_class = block_id+"-modal-minimize";
		  var modal_minimized_class = block_id+"-modal-minimized";
		  
		  $(css_identity+block_id).wrap('<div id="popup-blocks" class="'+modal_class+'"></div>');

		  if (values.minimize == 1) {
		  	$(css_identity+block_id).prepend($('<span class="'+modal_minimize_class+' spb_minimize">-</span>'));
			  $("."+modal_class).before($('<span class="'+modal_minimized_class+' spb_minimized"></span>'));  		   	
		  }
		  if (values.close == 1) {
				$(css_identity+block_id).prepend($('<span class="'+modal_close_class+' spb_close">&times;</span>'));		
		  } 	
  
	    if (values.overlay == 1) {
	    	$("."+modal_class).addClass("spb_overlay");
	    }
    	$(css_identity+block_id).addClass("spb-popup-main-wrapper");

			switch (values.layout) {
				// Top left
			  case '0':
			    $(css_identity+block_id).addClass("spb_top_left");
				  $(css_identity+block_id).css({					  
				  	"width": values.width,
				  });	 
			    break;
			  // Top right
			  case '1':
			  $(css_identity+block_id).addClass("spb_top_right");
				  $(css_identity+block_id).css({
				  	"width": values.width,
				  });
			    break;
			  // Bottom left  
			  case '2':
			    $(css_identity+block_id).addClass("spb_bottom_left");
				  $(css_identity+block_id).css({					  	
				  	"width": values.width,
				  });
			    break;
			  // Bottom right  
			  case '3':
			    $(css_identity+block_id).addClass("spb_bottom_right");
				  $(css_identity+block_id).css({
				  	"width": values.width,
				  });
			     break;
			  // Center
			  case '4':
			    $(css_identity+block_id).addClass("spb_center");
				  $(css_identity+block_id).css({
				  	"width": values.width,
				  });
			    break;
			  // Top Center
			  case '5':
			    $(css_identity+block_id).addClass("spb_top_center");
				  $(css_identity+block_id).css({
				  				  	
				  });
			    break;
			  // Top bar
			  case '6':
			    $(css_identity+block_id).addClass("spb_top_bar");
				  $(css_identity+block_id).css({
						
				  });
			    break;
			  // Right bar
			  case '7':
			    $(css_identity+block_id).addClass("spb_bottom_bar");
				  $(css_identity+block_id).css({
				  	
				  });
			    break;
			  // Bottom bar
			  case '8':
			    $(css_identity+block_id).addClass("spb_left_bar");
				  $(css_identity+block_id).css({
				  	"width": values.width,
				  });
			    break;		
			  // Right bar
			  case '9':
			    $(css_identity+block_id).addClass("spb_right_bar");
				  $(css_identity+block_id).css({
				  	"width": values.width,
				  });
			    break;				    		    				    				    
			}
			if (values.trigger == 0 && values.delay > 0) {
				var delays = values.delay * 1000;
			  $("."+modal_class).hide();
			  $("."+modal_class).delay(delays).fadeIn('slow');
			} 
			else if(values.trigger == 1) {
				$("."+modal_class).hide();
		    $(values.trigger_selector).click(function(){
				  $("."+modal_class).show();
		    });				
			} 
	    $("."+modal_close_class).click(function(){
			  $("."+modal_class).hide();
	    });
	    $("."+modal_minimize_class).click(function(){
			  $("."+modal_class).hide();
			  $("."+modal_minimized_class).show();
	    });
	    $("."+modal_minimized_class).click(function(){
			  $("."+modal_class).show();
			  $("."+modal_minimized_class).hide();
	    });
			if(values.escape == 1) {
				$(document).keyup(function(e) {
				  if (e.keyCode == 27) { // escape key maps to keycode `27`
				    $("."+modal_class).hide();
				    $("."+modal_minimized_class).show();
				  }
				});
			}
		});
		// foreach end


		function createCookie(name,value,days) {
		    if (days) {
		        var date = new Date();
		        date.setTime(date.getTime()+(days*24*60*60*1000));
		        var expires = "; expires="+date.toGMTString();
		    }
		    else var expires = "";
		    document.cookie = name+"="+value+expires+"; path=/";
		}

		function readCookie(name) {
		    var nameEQ = name + "=";
		    var ca = document.cookie.split(';');
		    for(var i=0;i < ca.length;i++) {
		        var c = ca[i];
		        while (c.charAt(0)==' ') c = c.substring(1,c.length);
		        if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
		    }
		    return null;
		}

		function eraseCookie(name) {
		    createCookie(name,"",-1);
		}

		// Erase the cookie (only works on page loads after the cookie was created)
		// eraseCookie('myCookie');


	});

})(jQuery, Drupal);
